searchNodes=[{"ref":"Erps.html","title":"Erps","type":"module","doc":"Erps is an OTP-compliant remote protocol service The general purpose of Erps is to extend the GenServer primitives over public networks using TLS authentication and encryption without using OTP standard distribution, for cases when latency, reliability, or network toplogy properties make using erlang distribution unfavorable or unreliable you prefer to use erlang distributed clusters strictly contain members of a given type, and have an orthogonal channel for cluster-to-cluster communication. Erps is an asymmetric protocol, which means there are distinct roles for client and server. An Erps client is a &#39;dumb proxy&#39; for a remote GenServer, forwarding all of its call/2 and cast/2 requests to the Erps server. Security model Erps currently presumes that once authenticated, both ends of the Erps connection are trusted, and provides only basic security measures to protect the server and the client. In particular, one of the strategies, Erps.Transport.OneWayTls, is still in-progress but should be considered experimental and insecure. Updates to improve the security model of this stratgy are welcome. Distribution and Worker pools There are no provisions for supporting out-of-the-box &#39;smart&#39; distribution defaults or smart worker pool defaults, but this is planned. Examples Examples on how to set up basic clients and servers are provided in in the documentation for Erps.Client and Erps.Server"},{"ref":"Erps.Client.html","title":"Erps.Client","type":"behaviour","doc":"Create an Erps client GenServer. The best way to think of an Erps client is that it is a GenServer that forwards its call/2 and cast/2 callbacks to a remote GenServer over a LAN or WAN. This callbacks would normally be provided by standard GenServer.call/2 and GenServer.cast/2 semantics over erlang distribution but in some cases you may want to issue a remote protocol request over high-latency or unreliable network stretches, or in cases where you would like to have an OTP-supervised connection orthogonal to standard erlang distribution semantics. Basic operation Presuming you have set up an Erps server GenServer on some host at @hostname, you can connect the client and the server simply by instantiating the server module. Example defmodule ErpsClient do use Erps.Client @hostname &lt;...&gt; @port &lt;...&gt; def start_link, do: Erps.Client.start_link(__MODULE__, :ok, server: @hostname, port: @port, tls_opts: [...]) def init(init_state), do: {:ok, init_state} end {:ok, client} = ErpsClient.start_link GenServer.call(client, :some_remote_call) # =&gt; :some_remote_response Module options :version the version of your Erps API messages. Should be a SemVer string. see Version for more information. :identifier a binary identifier for your Erps API endpoint. Maximum 12 bytes, suggested to be human-readable. :sign_with defines the cryptographic signing function for your Erps client/server pair. May take one of two forms: function (where function is an atom) calls the signing function module.function/2 with the unsigned binary as the first parameter, and the hmac_key (see start_link/3 options) as the second parameter. The hmac_key is passed to the function in the event that the client has a KV store which should be queried to find the appropriate signing key for the requested connection instance. module.function/2 should emit a 32-byte signature in response. {external_module, function} calls external_module.function/2 in the same fashion as above. :safe (see :erlang.binary_to_term/2), for decoding terms. If set to false, then allows undefined atoms and lambdas to be passed via the protocol. This should be used with extreme caution, as disabling safe mode can be an attack vector. (defaults to true) Example defmodule MyClient do use Erps.Client, version: &quot;0.2.4&quot;, identifier: &quot;my_api&quot;, sign_with: :signing, safe: false def signing(binary, hmac_key) do :crypto.mac(:hmac, :sha256, SecretProvider.secret_for(hmac_key), binary) end def start_link(iv) do Erps.Client.start_link(__MODULE__, init, hmac_key: &quot;ABCDEFGHIJKLMNOP&quot;, server: &quot;my_api-server.example.com&quot;, port: 4747, transport: Erps.Transport.Tls, tls_opts: [...]) end def init(iv), do: {:ok, iv} end"},{"ref":"Erps.Client.html#c:handle_continue/2","title":"Erps.Client.handle_continue/2","type":"callback","doc":"Invoked when an internal callback requests a continuation, using {:noreply, state, {:continue, continuation}}, or from init/1 using {:ok, state, {:continue, continuation}} The continuation is passed as the first argument of this callback. Most useful if init/1 functionality is long-running and needs to be broken up into separate parts so that the calling start_link/3 doesn&#39;t block. see: GenServer.handle_continue/2. Return codes {:noreply, new_state} continues the loop with new state new_state {:noreply, new_state, timeout} causes a :timeout message to be sent to handle_info/2 if no other message comes by {:noreply, new_state, :hibernate}, causes a hibernation event (see :erlang.hibernate/3) {:noreply, new_state, {:continue, term}} causes a continuation to be triggered after the message is handled, it will be sent to c:handle_continue/3 {:stop, reason, new_state} terminates the loop, passing new_state to terminate/2, if it&#39;s implemented."},{"ref":"Erps.Client.html#c:handle_info/2","title":"Erps.Client.handle_info/2","type":"callback","doc":"Invoked to handle general messages sent to the client process. Most useful if the client needs to be attentive to system messages, such as nodedown or monitored processes, but also useful for internal timeouts. see: GenServer.handle_info/2. Return codes see return codes for handle_continue/2"},{"ref":"Erps.Client.html#c:handle_push/2","title":"Erps.Client.handle_push/2","type":"callback","doc":"Invoked to handle Erps.Server.push/2 messages. push is the push message sent by a Erps.Server.push/2 and state is the current state of the Erps.Client. Return codes see return codes for handle_continue/2"},{"ref":"Erps.Client.html#c:init/1","title":"Erps.Client.init/1","type":"callback","doc":"Invoked to set up the process. Like GenServer.init/1, this function is called from inside the process immediately after start_link/3 or start/3. Return codes {:ok, state} a succesful startup of your intialization logic and sets the internal state of your server to state. {:ok, state, timeout} the above, plus a :timeout atom will be sent to handle_info/2 if no other messages come by. {:ok, state, :hibernate} successful startup, followed by a hibernation event (see :erlang.hibernate/3) {:ok, state, {:continue, term}} successful startup, and causes a continuation to be triggered after the message is handled, sent to c:handle_continue/3 :ignore - Drop the gen_server creation request, because for some reason it shouldn&#39;t have started. {:stop, reason} - a failure in creating the gen_server. Results in {:error, reason} being propagated as the result of the start_link"},{"ref":"Erps.Client.html#start/3","title":"Erps.Client.start/3","type":"function","doc":"starts a client GenServer, not linked to the caller. Most useful for tests. see start_link/3 for a description of avaliable options."},{"ref":"Erps.Client.html#start_link/3","title":"Erps.Client.start_link/3","type":"function","doc":"starts a client GenServer, linked to the caller. Will attempt to contact the server over the specified transport strategy. If the connection fails, the client will be placed in an invalid state until connection succeeds, with a reconnect interval specified in the module options. options :server IP address of the target server (required) :port IP port of the target server (required) :transport module for communication transport strategy :keepalive time interval for sending a TCP/IP keepalive token. :hmac_key one of two options: function/0 a zero-arity function which can be used to fetch the key at runtime binary a directly instrumented value (this could be fetched at vm startup time and pulled from System.get_env/1 or Application.get_env/2) :tls_opts options for setting up a TLS connection. :cacertfile path to the certificate of your signing authority. (required) :certfile path to the server certificate file. (required for Erps.Transport.Tls) :keyfile path to the signing key. (required for Erps.Transport.Tls) see GenServer.start_link/3 for a description of further options."},{"ref":"Erps.Client.html#c:terminate/2","title":"Erps.Client.terminate/2","type":"callback","doc":"Invoked when the client is about to exit. This would usually occur due to handle_push/2 returning a {:stop, reason, new_state} tuple, but also if the TCP connection happens to go down."},{"ref":"Erps.Client.html#t:hmac_function/0","title":"Erps.Client.hmac_function/0","type":"type","doc":""},{"ref":"Erps.Client.html#t:signing_function/0","title":"Erps.Client.signing_function/0","type":"type","doc":""},{"ref":"Erps.Server.html","title":"Erps.Server","type":"behaviour","doc":"Create an Erps server GenServer. An Erps server is just a GenServer that has its call/2 and cast/2 callbacks connected to the external network over a transport portocol. Basic Operation Presuming you have set up TLS credentials, you can instantiate a server in basically the same way that you would instantiate a GenServer: defmodule ErpsServer do use Erps.Server @port &lt;...&gt; def start_link, do: Erps.Server.start_link(__MODULE__, :ok, port: @port, tls_opts: [...]) @impl true def init(init_state), do: {:ok, init_state} def handle_call(:some_remote_call, state) do {:reply, :some_remote_response, state} end end Now you may either access these values as a normal, local GenServer, or access them via Erps.Client (see documentation) for the implementation. {:ok, server} = ErpsServer.start_link() GenServer.call(server, :some_remote_call) #==&gt; :some_remote_response {:ok, client} = ErpsClient.start_link() GenServer.call(client, :some_remote_call) #==&gt; :some_remote_response Module Options :identifier a binary identifier for your Erps API endpoint. Maximum 12 bytes, suggested to be human-readable. :versions client semvers which are accepted. See the &quot;requirements&quot; section in Version. :safe (see :erlang.binary_to_term/2), for decoding terms. If set to false, then allows undefined atoms and lambdas to be passed via the protocol. This should be used with extreme caution, as disabling safe mode can be an attack vector. (defaults to true) :port - sets the TCP/IP port that the server will listen to. If you don&#39;t set it or set it to 0 it will pick a random port, which is useful for testing purposes. :transport - set the transport module, which must implement Erps.Transport.Api behaviour. If you set it to false, the Erps server will act similarly to a GenServer (with some overhead). Example defmodule MyServer do use Erps.Server, versions: &quot;~&gt; 0.2.4&quot;, identifier: &quot;my_api&quot;, safe: false def start_link(iv) do Erps.Server.start_link(__MODULE__, init, port: , tls_opts: [...]) end def init(iv), do: {:ok, iv} end Magical features The following functions are hoisted to your server module so that you can call them in your code with clarity and less boilerplate: port/1 push/2 connections/1 disconnect/2"},{"ref":"Erps.Server.html#connections/1","title":"Erps.Server.connections/1","type":"function","doc":"queries the server to retrieve a list of all clients that are connected to the server."},{"ref":"Erps.Server.html#disconnect/2","title":"Erps.Server.disconnect/2","type":"function","doc":"instruct the server to drop one of its connections. returns {:error, :enoent} if the connection is not in its list of active connections."},{"ref":"Erps.Server.html#c:filter/2","title":"Erps.Server.filter/2","type":"callback","doc":"used to filter messages from remote clients, allowing you to restrict your api. The first term is either :call or :cast, indicating which type of api protocol the filter applies to, followed by the term to be checked for filtering. A true response means allow, and a false response means drop. Defaults to fn _, _ -&gt; true end (which is permissive)."},{"ref":"Erps.Server.html#c:handle_call/3","title":"Erps.Server.handle_call/3","type":"callback","doc":"similar to GenServer.handle_call/3, but handles content from both local and remote clients. The from term might contain a opaque term which represents a return address for a remote client, but you may use this term as expected in reply/2. Return codes {:reply, reply, new_state} replies, then updates the state of the Server. {:reply, reply, new_state, timeout} replies, then causes a :timeout message to be sent to handle_info/2 if no other message comes by {:reply, reply, new_state, :hibernate} replies, then causes a hibernation event (see :erlang.hibernate/3) {:reply, reply, new_state, {:continue, term}} replies, then causes a continuation to be triggered after the message is handled, it will be sent to c:handle_continue/3 and all return codes supported by GenServer.handle_cast/2"},{"ref":"Erps.Server.html#c:handle_cast/2","title":"Erps.Server.handle_cast/2","type":"callback","doc":"similar to GenServer.handle_cast/2, but handles content from both local and remote clients (if the content has been successfully filtered). Return codes {:noreply, new_state} continues the loop with new state new_state {:noreply, new_state, timeout} causes a :timeout message to be sent to handle_info/2 if no other message comes by {:noreply, new_state, :hibernate}, causes a hibernation event (see :erlang.hibernate/3) {:noreply, new_state, {:continue, term}} causes a continuation to be triggered after the message is handled, it will be sent to c:handle_continue/3 {:stop, reason, new_state} terminates the loop, passing new_state to terminate/2, if it&#39;s implemented."},{"ref":"Erps.Server.html#c:handle_continue/2","title":"Erps.Server.handle_continue/2","type":"callback","doc":"Invoked when an internal callback requests a continuation, using {:noreply, state, {:continue, continuation}}, or from init/1 using {:ok, state, {:continue, continuation}} see: GenServer.handle_continue/2. Return codes see return codes for handle_cast/2"},{"ref":"Erps.Server.html#c:handle_info/2","title":"Erps.Server.handle_info/2","type":"callback","doc":"Invoked to handle general messages sent to the client process. Most useful if the client needs to be attentive to system messages, such as nodedown or monitored processes, but also useful for internal timeouts. see: GenServer.handle_info/2. Return codes see return codes for handle_cast/2"},{"ref":"Erps.Server.html#c:init/1","title":"Erps.Server.init/1","type":"callback","doc":"Invoked to set up the process. Like GenServer.init/1, this function is called from inside the process immediately after start_link/3 or start/3. Return codes {:ok, state} a succesful startup of your intialization logic and sets the internal state of your server to state. {:ok, state, timeout} the above, plus a :timeout atom will be sent to handle_info/2 if no other messages come by. {:ok, state, :hibernate} successful startup, followed by a hibernation event (see :erlang.hibernate/3) {:ok, state, {:continue, term}} successful startup, and causes a continuation to be triggered after the message is handled, sent to c:handle_continue/3 :ignore - Drop the gen_server creation request, because for some reason it shouldn&#39;t have started. {:stop, reason} - a failure in creating the gen_server. Results in {:error, reason} being propagated as the result of the start_link"},{"ref":"Erps.Server.html#port/1","title":"Erps.Server.port/1","type":"function","doc":"queries the server to retrieve the TCP port that it&#39;s bound to to receive protocol messages. Useful if you have initiated your server with port: 0, especially in tests."},{"ref":"Erps.Server.html#push/2","title":"Erps.Server.push/2","type":"function","doc":"pushes a message to all connected clients. Causes client Erps.Client.handle_push/2 callbacks to be triggered."},{"ref":"Erps.Server.html#reply/2","title":"Erps.Server.reply/2","type":"function","doc":"sends a reply to either a local process or a remotely connected client. naturally takes the from value passed in to the second parameter of handle_call/3."},{"ref":"Erps.Server.html#start/3","title":"Erps.Server.start/3","type":"function","doc":"starts a server GenServer, not linked to the caller. Most useful for tests. see start_link/3 for a description of avaliable options."},{"ref":"Erps.Server.html#start_link/3","title":"Erps.Server.start_link/3","type":"function","doc":"starts a server GenServer, linked to the caller. options :port tcp port that the server should listen to. Use 0 to pick an unused port and port/1 to retrieve that port number (useful for testing). You may also set it to false if you want the server to act as a normal GenServer (this is useful if you need a configuration-dependent behaviour) :transport transport module (see Erps.Transport.Api) :tls_opts options for TLS authorization and encryption. Should include: :cacertfile path to the certificate of your signing authority. :certfile path to the server certificate file. :keyfile path to the signing key. see GenServer.start_link/3 for a description of further options."},{"ref":"Erps.Server.html#c:terminate/2","title":"Erps.Server.terminate/2","type":"callback","doc":"see: GenServer.terminate/2."},{"ref":"Erps.Server.html#t:from/0","title":"Erps.Server.from/0","type":"opaque","doc":"a from term that is either a local from, compatible with GenServer.from/0 or an opaque term that represents a connected remote client."},{"ref":"Erps.Server.html#t:server/0","title":"Erps.Server.server/0","type":"type","doc":""},{"ref":"Erps.Transport.Api.html","title":"Erps.Transport.Api","type":"behaviour","doc":"Encapsulates a common API which describes a transport strategy. Currently the available transport strategies are: Erps.Transport.Tcp: unencrypted, unauthenticated communication. Only appropriate in :dev and :test environments. Erps.Transport.Tls: two-way authenticated, encrypted communication, using X509 TLS encryption. This is the general use case for Erps, for point-to-point API services including over untrusted networks. Erps.Transport.OneWayTls: one-way authenticated, encrypted communication, using X509 TLS encryption. The server must present its authentication tokens and the clients may call in. This is akin to traditional Web API or gRPC endpoints management, but still requires manual certificate distribution to your client endpoints. You may use this API to implement your own transport layers, or use it to mock responses in tests. Each of the API callbacks is either a client callback, a server callback, or a &quot;both&quot; callback."},{"ref":"Erps.Transport.Api.html#c:accept/2","title":"Erps.Transport.Api.accept/2","type":"callback","doc":"(server) temporarily blocks the server waiting for a connection request."},{"ref":"Erps.Transport.Api.html#c:connect/3","title":"Erps.Transport.Api.connect/3","type":"callback","doc":"(client) initiates a unencrypted connection from the client to the server. The connection must be opened with active: false, or upgrade guarantees cannot be ensured for X509-TLS connections."},{"ref":"Erps.Transport.Api.html#c:handshake/2","title":"Erps.Transport.Api.handshake/2","type":"callback","doc":"(server) upgrades the TCP connection to an authenticated, encrypted connection. Also should upgrade the connection from active: false to active: true. In the case of an unencrypted transport, e.g. Erps.Transport.Tcp, only performs the connection upgrade."},{"ref":"Erps.Transport.Api.html#listen/2","title":"Erps.Transport.Api.listen/2","type":"function","doc":"a generic &quot;listen&quot; which calls :gen_tcp.listen/2 that filters out any ssl options passed in (see listen/2)"},{"ref":"Erps.Transport.Api.html#c:listen/2","title":"Erps.Transport.Api.listen/2","type":"callback","doc":"(server) opens a TCP port to listen for incoming connection requests. Opens the port in active: false to ensure correct synchronization of handshake/2 and upgrade!/2 events. NB: tls options provided will be passed into listen to allow servers that require tls options to fail early when launching if the user doesn&#39;t supply them."},{"ref":"Erps.Transport.Api.html#c:send/2","title":"Erps.Transport.Api.send/2","type":"callback","doc":"(both) sends a packet down the appropriate transport channel"},{"ref":"Erps.Transport.Api.html#c:transport_type/0","title":"Erps.Transport.Api.transport_type/0","type":"callback","doc":"(both) provides a hint to GenServer.handle_info/2 as to what sorts of active packet messages to expect."},{"ref":"Erps.Transport.Api.html#c:upgrade!/2","title":"Erps.Transport.Api.upgrade!/2","type":"callback","doc":"(client) upgrades an TCP connection to an encrypted, authenticated connection. Also should upgrade the connection from active: false to active: true In the case of an unencrypted transport, e.g. Erps.Transport.Tcp, only perfroms the connection upgrade."},{"ref":"Erps.Transport.Api.html#t:socket/0","title":"Erps.Transport.Api.socket/0","type":"type","doc":""},{"ref":"Erps.Transport.None.html","title":"Erps.Transport.None","type":"module","doc":"implements no transport, which basically turns the Erps server into a basic GenServer"},{"ref":"Erps.Transport.OneWayTls.html","title":"Erps.Transport.OneWayTls","type":"module","doc":"implements a one-way TLS transport strategy. this transport is equivalent to a traditional http/grpc transport, where a client does not have to be authenticated to a server, but the server must be authenticated to the client. WARNING: currently, there must exist a high level of trust between the client and the server, as certain attack vectors have not been closed yet. Use at your own risk!"},{"ref":"Erps.Transport.OneWayTls.html#accept/2","title":"Erps.Transport.OneWayTls.accept/2","type":"function","doc":"Callback implementation for Erps.Transport.Api.accept/2."},{"ref":"Erps.Transport.OneWayTls.html#connect/3","title":"Erps.Transport.OneWayTls.connect/3","type":"function","doc":"Callback implementation for Erps.Transport.Api.connect/3."},{"ref":"Erps.Transport.OneWayTls.html#handshake/2","title":"Erps.Transport.OneWayTls.handshake/2","type":"function","doc":"(server) initiates a client upgrade!/2 request, by upgrading to an encrypted connection. Performs no authentication of the client. Callback implementation for Erps.Transport.Api.handshake/2."},{"ref":"Erps.Transport.OneWayTls.html#listen/2","title":"Erps.Transport.OneWayTls.listen/2","type":"function","doc":"(server) opens a TCP port to listen for incoming connection requests. Verifies that the tls options :cacertfile, :certfile, and :keyfile exist under the keyword :tls_opts, and point to existing files (but not the validity of their authority chain or their crytographic signing). Callback implementation for Erps.Transport.Api.listen/2."},{"ref":"Erps.Transport.OneWayTls.html#send/2","title":"Erps.Transport.OneWayTls.send/2","type":"function","doc":"Callback implementation for Erps.Transport.Api.send/2, via :ssl.send/2"},{"ref":"Erps.Transport.OneWayTls.html#upgrade!/2","title":"Erps.Transport.OneWayTls.upgrade!/2","type":"function","doc":"(client) responds to a server TLS handshake/2 request, by upgrading to an encrypted connection. Verifies the identity of the server CA, and reject if it&#39;s not a valid peer. Callback implementation for Erps.Transport.Api.upgrade!/2."},{"ref":"Erps.Transport.Tcp.html","title":"Erps.Transport.Tcp","type":"module","doc":"implements a tcp transport strategy."},{"ref":"Erps.Transport.Tcp.html#accept/2","title":"Erps.Transport.Tcp.accept/2","type":"function","doc":"Callback implementation for Erps.Transport.Api.accept/2."},{"ref":"Erps.Transport.Tcp.html#connect/3","title":"Erps.Transport.Tcp.connect/3","type":"function","doc":"Callback implementation for Erps.Transport.Api.connect/3."},{"ref":"Erps.Transport.Tcp.html#handshake/2","title":"Erps.Transport.Tcp.handshake/2","type":"function","doc":"upgrades the socket to active: true. Does not request the client-side for an upgrade to an authenticated or encrypted channel. Callback implementation for Erps.Transport.Api.upgrade!/2."},{"ref":"Erps.Transport.Tcp.html#listen/2","title":"Erps.Transport.Tcp.listen/2","type":"function","doc":"Callback implementation for Erps.Transport.Api.listen/2."},{"ref":"Erps.Transport.Tcp.html#send/2","title":"Erps.Transport.Tcp.send/2","type":"function","doc":"Callback implementation for Erps.Transport.Api.send/2, via :gen_tcp.send/2"},{"ref":"Erps.Transport.Tcp.html#upgrade!/2","title":"Erps.Transport.Tcp.upgrade!/2","type":"function","doc":"upgrades the socket to active: true. Does not upgrade to an authenticated or encrypted channel. Callback implementation for Erps.Transport.Api.upgrade!/2."},{"ref":"Erps.Transport.Tls.html","title":"Erps.Transport.Tls","type":"module","doc":"implements a two-way TLS transport strategy. this transport is useful when you have trusted clients and servers that are authenticated against each other and must have an encrypted channel over WAN."},{"ref":"Erps.Transport.Tls.html#accept/2","title":"Erps.Transport.Tls.accept/2","type":"function","doc":"Callback implementation for Erps.Transport.Api.accept/2."},{"ref":"Erps.Transport.Tls.html#connect/3","title":"Erps.Transport.Tls.connect/3","type":"function","doc":"Callback implementation for Erps.Transport.Api.connect/3."},{"ref":"Erps.Transport.Tls.html#handshake/2","title":"Erps.Transport.Tls.handshake/2","type":"function","doc":"(server) a specialized function that generates a match function option used to verify that the incoming client is bound to a single ip address."},{"ref":"Erps.Transport.Tls.html#listen/2","title":"Erps.Transport.Tls.listen/2","type":"function","doc":"Callback implementation for Erps.Transport.Api.listen/2, via Erps.Transport.OneWayTls.listen/2."},{"ref":"Erps.Transport.Tls.html#send/2","title":"Erps.Transport.Tls.send/2","type":"function","doc":"Callback implementation for Erps.Transport.Api.send/2, via :ssl.send/2."},{"ref":"Erps.Transport.Tls.html#single_ip_check/1","title":"Erps.Transport.Tls.single_ip_check/1","type":"function","doc":"(client) a specialized function that generates a match function option used to verify that the targetted server is bound to a single ip address. should be used as in as the :customize_hostname_check option for clients"},{"ref":"Erps.Transport.Tls.html#upgrade!/2","title":"Erps.Transport.Tls.upgrade!/2","type":"function","doc":"Callback implementation for Erps.Transport.Api.upgrade!/2, via Erps.Transport.OneWayTls.upgrade!/2."}]